/**
 * @license
 * Copyright © 2020 Intuilab
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * The Software is provided "as is", without warranty of any kind, express or implied, including but not limited to the warranties of merchantability,
 * fitness for a particular purpose and noninfringement. In no event shall the authors or copyright holders be liable for any claim, damages or other liability,
 * whether in an action of contract, tort or otherwise, arising from, out of or in connection with the Software or the use or other dealings in the Software.
 *
 * Except as contained in this notice, the name of Intuilab shall not be used in advertising or otherwise to promote the sale,
 * use or other dealings in this Software without prior written authorization from Intuilab.
 */

/**
* Inheritance on EventEmitter base class
* @type {EventEmitter}
*/
TextConcatenation.prototype = new EventEmitter();
TextConcatenation.prototype.constructor = TextConcatenation;

/**
* @constructor
*/
function TextConcatenation() {
    this.inputA = "";
    this.inputB = "";
	this.inputC = "";
	this.inputD = "";
    this.inputE = "";
	this.inputF = "";
    this.inputG = "";
	this.inputH = "";
	this.inputI = "";
	this.inputJ = "";
	this.inputK = "";
	this.inputL = "";
    this.output = null;
}

/**
 * Setters for different properties
 */
TextConcatenation.prototype.setInputA = function (value) {
	value = parseString(value);
    if (this.inputA !== value) {
        this.inputA = value;
        this.emit('inputAChanged', [this.inputA]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputB = function (value) {
	value = parseString(value);
	if (this.inputB !== value) {
        this.inputB = value;
        this.emit('inputBChanged', [this.inputB]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputC = function (value) {
	value = parseString(value);
    if (this.inputC !== value) {
        this.inputC = value;
        this.emit('inputCChanged', [this.inputC]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputD = function (value) {
	value = parseString(value);
    if (this.inputD !== value) {
        this.inputD = value;
        this.emit('inputDChanged', [this.inputD]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputE = function (value) {
	value = parseString(value);
    if (this.inputE !== value) {
        this.inputE = value;
        this.emit('inputEChanged', [this.inputE]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputF = function (value) {
	value = parseString(value);
    if (this.inputF !== value) {
        this.inputF = value;
        this.emit('inputFChanged', [this.inputF]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputG = function (value) {
	value = parseString(value);
    if (this.inputG !== value) {
        this.inputG = value;
        this.emit('inputGChanged', [this.inputG]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputH = function (value) {
	value = parseString(value);
    if (this.inputH !== value) {
        this.inputH = value;
        this.emit('inputHChanged', [this.inputH]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputI = function (value) {
	value = parseString(value);
    if (this.inputI !== value) {
        this.inputI = value;
        this.emit('inputIChanged', [this.inputI]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputJ = function (value) {
	value = parseString(value);
    if (this.inputJ !== value) {
        this.inputJ = value;
        this.emit('inputJChanged', [this.inputJ]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputK = function (value) {
	value = parseString(value);
    if (this.inputK !== value) {
        this.inputK = value;
        this.emit('inputKChanged', [this.inputK]);

        this.evaluate();
    }
};

TextConcatenation.prototype.setInputL = function (value) {
	value = parseString(value);
    if (this.inputL !== value) {
        this.inputL = value;
        this.emit('inputLChanged', [this.inputL]);

        this.evaluate();
    }
};

/**
 * Method (exposed on IA side) to set multiple inputs at once
 */
TextConcatenation.prototype.setInputs = function (InputA, InputB, InputC, InputD, InputE, InputF, InputG, InputH, InputI, InputJ, InputK, InputL) {
    
	InputA = parseString(InputA);
	InputB = parseString(InputB);
	InputC = parseString(InputC);
	InputD = parseString(InputD);
	InputE = parseString(InputE);
	InputF = parseString(InputF);
	InputG = parseString(InputG);
	InputH = parseString(InputH);
	InputI = parseString(InputI);
	InputJ = parseString(InputJ);
	InputK = parseString(InputK);
	InputL = parseString(InputL);
	
    if ((this.inputA !== InputA) || (this.inputB !== InputB) || (this.inputC !== InputC) || (this.inputD !== InputD) || (this.inputE !== InputE) || (this.inputF !== InputF) || (this.inputG !== InputG) || (this.inputH !== InputH) || (this.inputI !== InputI) || (this.inputJ !== InputJ) || (this.inputK !== InputK) || (this.inputL !== InputL)){
        if (this.inputA !== InputA){
            this.inputA = InputA;
            this.emit('inputAChanged', [this.inputA]);
        }
        if (this.inputB !== InputB){
            this.inputB = InputB;
            this.emit('inputBChanged', [this.inputB]);
        }
		if (this.inputC !== InputC){
            this.inputC = InputC;
            this.emit('inputCChanged', [this.inputC]);
        }
		if (this.inputD !== InputD){
            this.inputD = InputD;
            this.emit('inputDChanged', [this.inputD]);
        }
		if (this.inputE !== InputE){
            this.inputE = InputE;
            this.emit('inputEChanged', [this.inputE]);
        }
		if (this.inputF !== InputF){
            this.inputF = InputF;
            this.emit('inputFChanged', [this.inputF]);
        }
		if (this.inputG !== InputG){
            this.inputG = InputG;
            this.emit('inputGChanged', [this.inputG]);
        }
		if (this.inputH !== InputH){
            this.inputH = InputH;
            this.emit('inputHChanged', [this.inputH]);
        }
		if (this.inputI !== InputI){
            this.inputI = InputI;
            this.emit('inputIChanged', [this.inputI]);
        }
		if (this.inputJ !== InputJ){
            this.inputJ = InputJ;
            this.emit('inputJChanged', [this.inputJ]);
        }
		if (this.inputK !== InputK){
            this.inputK = InputK;
            this.emit('inputKChanged', [this.inputK]);
        }
		if (this.inputL !== InputL){
            this.inputL = InputL;
            this.emit('inputLChanged', [this.inputL]);
        }
        this.evaluate();
    }
};

/**
 * Function to parse a string Input.
 */
function parseString( inputValue )
{
	var inputType = typeof inputValue
	if ( inputType === 'string')
	{
		return inputValue;
	}
	else if (inputType === 'boolean' || inputType === 'number' || inputType === 'bigint' )
	{
		return inputValue.toString();
	}
	return "";
}

/**
 * Function used to concatenate all inputs, and then if necessary update the output.
 */
TextConcatenation.prototype.evaluate = function () {
    var newResult = this.inputA + this.inputB + this.inputC + this.inputD + this.inputE + this.inputF + this.inputG + this.inputH + this.inputI + this.inputJ + this.inputK + this.inputL;
    if (this.output !== newResult)
    {
        this.output = newResult;
        this.emit('outputChanged', [this.output]);
    }
};

